freeslot("MT_EUPHAPROPPELLER", "S_EUPHAPROPPELLER")

mobjinfo[MT_EUPHAPROPPELLER] = {
	doomednum = -1,
	spawnstate = S_EUPHAPROPPELLER,
	flags = MF_NOTHINK|MF_NOBLOCKMAP|MF_NOGRAVITY, //Die thinker, die
}
states[S_EUPHAPROPPELLER] = {
	sprite = SPR_PRPL,
	tics = -1,
}

addHook("ThinkFrame", do
	for euphorica in players.iterate
		if (euphorica.mo and euphorica.mo.valid) then
			local ov = euphorica.flameoverlay
			if (euphorica.mo.skin ~= "euphorica") then //Are you Euphorica? Ok. Make everything else valid.
				if (ov and ov.mo.valid) then
					P_RemoveMobj(ov.mo)
				end
			else
				if (not euphorica.mo.valid) then continue end //You're not Euphorica? Ok, end the script here.
				local drift = false
				local an = euphorica.frameangle
				local function ovs(t)
					return P_SpawnMobj(0,0,0,t or MT_EUPHAPROPPELLER) //Euphorica's underwater proppeller is spawned. at coodinates 0,0,0.
				end
				if (not euphorica.flameoverlay) then
					euphorica.flameoverlay = {mo = ovs()}
					continue
				end
				if (not euphorica.flameoverlay.mo.valid) then
					euphorica.flameoverlay.mo = ovs()
					continue
				end
				ov = ($).mo
				ov.target = euphorica.mo
				if (euphorica.mo.state == S_INVISIBLE)
				or (euphorica.mo.flags2 & MF2_DONTDRAW)
				or not (euphorica.mo.eflags & MFE_UNDERWATER)
				or (euphorica.mo.frame == R)
				or (gametype == GT_BATTLE and (euphorica.kartstuff[k_comebacktimer] != 0) and (euphorica.kartstuff[k_bumper] < 1)) then
					ov.sprite = SPR_NULL //Is Euphorica Alive, Healthy and Underwater?
				elseif ((euphorica.mo.frame == O) or (euphorica.mo.frame == P)) then
					ov.sprite = SPR_PRPL
					an = $ - ANGLE_45
				elseif ((euphorica.mo.frame == M) or (euphorica.mo.frame == N)) then
					ov.sprite = SPR_PRPL
					an = $ + ANGLE_45
				else
					ov.sprite = SPR_PRPL
				end
				ov.scale = euphorica.mo.scale
				ov.angle = euphorica.frameangle
				ov.flags = MF_NOTHINK|MF_NOBLOCKMAP|MF_NOGRAVITY
				ov.flags2 = euphorica.mo.flags2
				ov.eflags = euphorica.mo.eflags
				ov.tics = -1
				ov.frame = (leveltime/4 % F)|FF_FULLBRIGHT
				local z = euphorica.mo.z
				if (ov.flags2 & MF2_OBJECTFLIP)
				or (ov.eflags & MFE_VERTICALFLIP) then
					z = $ + euphorica.mo.height
				end
				P_TeleportMove(ov,euphorica.mo.x - FixedMul(ov.scale, FixedMul(FRACUNIT*2, cos(an))),euphorica.mo.y - 30 - FixedMul(ov.scale, FixedMul(FRACUNIT*2, sin(an))),z) //What if, I removed this line? Euphorica's propellwer wouldn't move.
			end
		end
	end
end) //I need to OMEGA end this right now
